/*
 *   This file is a part of the SteamWar software.
 *
 *   Copyright (C) 2023 SteamWar.de-Serverteam
 *
 *   This program is free software: you can redistribute it and/or modify
 *   it under the terms of the GNU Affero General Public License as published by
 *   the Free Software Foundation, either version 3 of the License, or
 *   (at your option) any later version.
 *
 *   This program is distributed in the hope that it will be useful,
 *   but WITHOUT ANY WARRANTY; without even the implied warranty of
 *   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
 *   GNU Affero General Public License for more details.
 *
 *   You should have received a copy of the GNU Affero General Public License
 *   along with this program.  If not, see <https://www.gnu.org/licenses/>.
 */

import {fetchWithToken, tokenStore} from "./repo.ts";
import type {SchematicInfo, SchematicList} from "@type/schem.ts";
import {SchematicInfoSchema, SchematicListSchema} from "@type/schem.ts";
import {derived} from "svelte/store";

export class SchematicRepo {
    constructor(private token: string) {
    }

    public async getRootSchematicList(): Promise<SchematicList> {
        return await fetchWithToken(this.token, "/schem").then(value => value.json()).then(SchematicListSchema.parse);
    }

    public async getSchematicList(id: number): Promise<SchematicList> {
        return await fetchWithToken(this.token, `/schem/${id}/list`).then(value => value.json()).then(SchematicListSchema.parse);
    }

    public async getSchematicInfo(id: number): Promise<SchematicInfo> {
        return await fetchWithToken(this.token, `/schem/${id}`).then(value => value.json()).then(SchematicInfoSchema.parse);
    }

    public async uploadSchematic(name: string, content: string) {
        return await fetchWithToken(this.token, "/schem", {
            method: "POST",
            body: JSON.stringify({
                name,
                content,
            }),
        });
    }
}

export const schemRepo = derived(tokenStore, ($token) => new SchematicRepo($token));